--
-- Class AbilityManager
--
--   Manages a list of AbilityManager

libAbilityCatalog = ...

local AbilityManager = {}
AbilityManager.__index = AbilityManager

function AbilityManager.Create()
	local obj = {}
	setmetatable(obj,AbilityManager)
	obj:Init()
	return obj
end

function AbilityManager:Init()
	self.ability = {}
	self.currentRole = nil
	self.currentAbilities = {}
end

function AbilityManager.CooldownBegin(handle, abilities)
	local time = Inspect.Time.Frame()
	for ability, value in pairs(abilities) do
		if(value > 1.5)then
			libAbilityCatalog.Event.Trigger.Ability(ability)
			libAbilityCatalog.AbilityManager.ability[ability] = time + value
		else
			libAbilityCatalog.AbilityManager.ability[ability] = nil
		end
	end
end

function AbilityManager.NewAbilities(handle, abilities)
  local self = libAbilityCatalog.AbilityManager
  local role = Inspect.TEMPORARY.Role()
  if(self.currentRole ~= role)then
  	self.currentRole = role
  	self.currentAbilities = {}
  end

	for ability in pairs(abilities) do
			libAbilityCatalog.Event.Trigger.Ability(ability)
			self.currentAbilities[ability] = true
	end
end

Command.Event.Attach(Event.Ability.New.Cooldown.Begin, AbilityManager.CooldownBegin, "Event.Ability.New.Cooldown.Begin")
Command.Event.Attach(Event.Ability.New.Cooldown.End, AbilityManager.CooldownBegin, "Event.Ability.New.Cooldown.Begin")
Command.Event.Attach(Event.Ability.New.Add, AbilityManager.NewAbilities,"AbilityManager.NewAbilities")
libAbilityCatalog.AbilityManager = AbilityManager.Create()


