--
-- Class CastbarManager
--
--   Manages a list of CastbarManager

libAbilityCatalog = ...

local CastbarManager = {}
CastbarManager.__index = CastbarManager

function CastbarManager.Create()
	local obj = {}
	setmetatable(obj,CastbarManager)
	obj:Init()
	return obj
end

function joinMyTables(t1, t2)
	 if(t1 ~= nil and t2 ~= nil)then
	   for k,v in pairs(t2) do
	      t1[k] = v
	   end
	 end
   return t1
end

function CastbarManager:Init()
	self.casting = {}
end

function CastbarManager.CastBarChange(handle, units)
	for unit, details in pairs(units) do
		if(details == false)then
			libAbilityCatalog.CastbarManager.casting[unit] = nil
		elseif(libAbilityCatalog.CastbarManager.casting[unit] == nil)then
			local c = Inspect.Unit.Castbar(unit)
			if(c.abilityNew ~= nil)then
				local d = Inspect.Ability.New.Detail(c.abilityNew)
				c = joinMyTables(d,c)
			end
			libAbilityCatalog.CastbarManager.casting[unit] = c
			libAbilityCatalog.Event.Trigger.Cast(unit,c)
		else
			-- no change - already recorded
		end
	end
end

Command.Event.Attach(Event.Unit.Castbar, CastbarManager.CastBarChange, "CastbarManager.CastBarChange")

libAbilityCatalog.CastbarManager = CastbarManager.Create()