--
--  Class CatalogItem

libAbilityCatalog = ...

libAbilityCatalog.CatalogItem = {}
local CatalogItem = libAbilityCatalog.CatalogItem
CatalogItem.__index = CatalogItem

function CatalogItem.Create()
	local obj = {}
	setmetatable(obj,CatalogItem)
	obj:Init()
	return obj
end

function CatalogItem:Init()
	self.id = nil
	self.name = nil
	self.icon = nil
	self.casted = nil
	self.description = ""
	self.abilityId = nil
	self.type = false
end

function CatalogItem:Serialize()
	section = {}
	section.name = self.name
	section.icon = self.icon
	section.type = self.type
	section.id = self.id
	section.casted = self.casted
	section.description = self.description
	section.abilityId = self.abilityId
	return section
end

function CatalogItem.Deserialize(id, section)
	b = CatalogItem.Create()
	b.id = id
	b.name = section.name
	b.icon = section.icon
	b.casted = section.casted
	b.type = section.type
	b.description = section.description or ""
	b.abilityId = section.abilityId
	return b
end

