
libAbilityCatalog = ...
libAbilityCatalog.addonId = "LibAbilityCatalog"
libAbilityCatalog.Event = {}
libAbilityCatalog.Event.Trigger = {}

libAbilityCatalog.Event.Trigger.Cast, libAbilityCatalog.Event.Cast = Utility.Event.Create(libAbilityCatalog.addonId, "Cast")
libAbilityCatalog.Event.Trigger.Buff, libAbilityCatalog.Event.Buff = Utility.Event.Create(libAbilityCatalog.addonId, "Buff")
libAbilityCatalog.Event.Trigger.Ability, libAbilityCatalog.Event.Ability = Utility.Event.Create(libAbilityCatalog.addonId, "Ability")
libAbilityCatalog.Event.Trigger.Loaded, libAbilityCatalog.Event.Loaded = Utility.Event.Create(libAbilityCatalog.addonId, "Loaded")
libAbilityCatalog.Event.Trigger.UnitRemoved, libAbilityCatalog.Event.UnitRemoved = Utility.Event.Create(libAbilityCatalog.addonId, "UnitRemoved")
libAbilityCatalog.Event.Trigger.UnitAdded, libAbilityCatalog.Event.UnitAdded = Utility.Event.Create(libAbilityCatalog.addonId, "UnitAdded")


libAbilityCatalog.units = {}
libAbilityCatalog.unitsRelation = {}

libAbilityCatalog.handledSpecifiers = { ["player"] = false,
																				["player.target"] = false,
																				["focus"] = false,
																				["focus.target"] = false,
																				["player.target.target"] = false,
																				["group01"] = false,
																				["group02"] = false,
																				["group03"] = false,
																				["group04"] = false,
																				["group05"] = false,
																				["group06"] = false,
																				["group07"] = false,
																				["group08"] = false,
																				["group09"] = false,
																				["group10"] = false,
																				["group11"] = false,
																				["group12"] = false,
																				["group13"] = false,
																				["group14"] = false,
																				["group15"] = false,
																				["group16"] = false,
																				["group17"] = false,
																				["group18"] = false,
																				["group19"] = false,
																				["group20"] = false,											
																			}
libTDebug.UIDebug:AddTable("AbilityCatalog.handledSpecifiers",libAbilityCatalog.handledSpecifiers)																			
libTDebug.UIDebug:AddTable("AbilityCatalog.unitsRelation",libAbilityCatalog.unitsRelation)
libTDebug.UIDebug:AddTable("AbilityCatalog.units",libAbilityCatalog.units)

function libAbilityCatalog.GetUnit(unitSpecifier)
	
	return libAbilityCatalog.handledSpecifiers[libTConstants.UnitSpecifiersStrings[unitSpecifier]]
end
													
local LAMain = {}
LAMain.__index = LAMain	
		
function LAMain.Create()
	local obj = {}
	setmetatable(obj,LAMain)
	obj:Init()
	return obj
end

function LAMain:Init()
	self.SlashCommands = {
	}
	self.description ="libAbilityCatalog"
end

function LAMain:Split(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={} ; i=1
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end
        return t
end

function LAMain.OnSlash(handle, parameterString)
	local self = libAbilityCatalog.LAMain
	local parameters =  self:Split(parameterString)
	local parameter = parameters[1]
	if (self.SlashCommands[parameter] ~= nil) then
		self.SlashCommands[parameter][1](parameters)
	else
		for key, value in pairs(self.SlashCommands) do
			print(string.format("/abilityCatalog %s - %s", key, value[2]))
		end
	end
end
											
function LAMain.SpecifiersChanged(unit, specifier)
	local unitSpecifierId = libTConstants.UnitSpecifiers[specifier]
	if(not unitSpecifierId) then return end
	libAbilityCatalog.handledSpecifiers[specifier] = unit
	-- remove unit from specifier list
	for unitId, specifiers in pairs(libAbilityCatalog.units) do
		if (bit.band(specifiers,unitSpecifierId)==unitSpecifierId)then
			libAbilityCatalog.units[unitId] = bit.bxor(unitSpecifierId,libAbilityCatalog.units[unitId])
			if(libAbilityCatalog.units[unitId] == 0) then
				libAbilityCatalog.units[unitId] = nil
				libAbilityCatalog.unitsRelation[unitId] = nil
				libAbilityCatalog.Event.Trigger.UnitRemoved(unitId)
			end
		end
	end
	if(unit and unitSpecifierId ~= nil)then
		-- add or update from specifierList
		local detail = Inspect.Unit.Detail(unit)
		libAbilityCatalog.units[unit] = libAbilityCatalog.units[unit] or 0
		libAbilityCatalog.units[unit] = bit.bor(libAbilityCatalog.units[unit],unitSpecifierId)
		if(detail)then
			libAbilityCatalog.unitsRelation[unit] = libTConstants.RelationMap[detail.relation or "hostile"]
		else
			libAbilityCatalog.unitsRelation[unit] = libTConstants.RelationMap["hostile"]
		end
		libAbilityCatalog.Event.Trigger.UnitAdded(unit)
	end
end

function LAMain.RunFirst(handle, units)
	for id, specifier in pairs(units) do
		if(specifier == "player")then
			libAbilityCatalog.Event.Trigger.Loaded()
			libAbilityCatalog.units[id] = libTConstants.UnitSpecifiers[specifier]
			Command.Event.Detach(Event.Unit.Availability.Full, LAMain.RunFirst)			
			for s, _ in pairs(libAbilityCatalog.handledSpecifiers) do
				local u = Inspect.Unit.Lookup(s)
				if (u ~= nil)then
					LAMain.SpecifiersChanged(u, s)
				end
			end			
			return
		end
	end
end

function LAMain.OnVariablesLoaded(event, addonId)
	if addonId ~= libAbilityCatalog.addonId then return end	
end

for specifier in pairs(libAbilityCatalog.handledSpecifiers) do
	local EventTable = Library.LibUnitChange.Register(specifier)
	Command.Event.Attach(EventTable, function (handle, unit) LAMain.SpecifiersChanged(unit, specifier) end, "BuffManager.ProcessUnits "..specifier.." changed")
end




libAbilityCatalog.LAMain = LAMain.Create()
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, LAMain.OnVariablesLoaded, "LAMain.OnVariablesLoaded")
Command.Event.Attach(Command.Slash.Register("abilityCatalog"), LAMain.OnSlash, "SlashRegisterCommand.libAbilityCatalog")
Command.Event.Attach(Event.Unit.Availability.Full, LAMain.RunFirst, "LAMain.RunFirst")