--
--  Class Encounter

local libEncounters = ...

libEncounters.Encounter = {}
local Encounter = libEncounters.Encounter
Encounter.__index = Encounter

function Encounter.Create()
	local obj = {}
	setmetatable(obj,Encounter)
	obj:Init()
	obj.id = libTUtility.uuid()
	return obj
end

function Encounter:Init()
  self.id = nil
  self.name = ""
  self.zone = ""
  self.raidSize =  ""
  self.units = {}
end

function Encounter:UnitMatch(unitsByUTID)
	for utid, unitDetails in pairs(unitsByUTID) do
		if self.units[utid] ~= nil then
			return true
		end
	end
	return false
end

function Encounter:Serialize()
	local item = {}
	item.id = self.id
	item.name = self.name
	item.zone = self.zone
	item.raidSize = self.raidSize
	item.units = {}
	for mobType, name in pairs(self.units) do
		item.units[mobType] = name
	end
	return item
end

function Encounter.Deserialize(section,e)
	if(e == nil)then
		e = Encounter.Create()
	end
	e.id = section.id
	e.name = section.name
	e.zone = section.zone
	e.raidSize = section.raidSize
	e.units = {}
	for mobType, name in pairs(section.units) do
		e.units[mobType] = name
	end
	return e
end