libTConstants = ...

libTConstants.UnitSpecifiers = {
	["player"] = 1,
	["player.target"] = 2,
	["focus"] = 4,
	["focus.target"] = 8,
	["player.target.target"] = 16
}

libTConstants.Unit = {
	PLAYER = 1,
	TARGET = 2,
	FOCUS = 4,
	FOCUSTARGET = 8,
	TARGETSTARGET = 16,
	toString = function (value)
		local s = ""
		if(bit.band(libTConstants.Unit.PLAYER, value)==libTConstants.Unit.PLAYER)then s = s .. "Player," end
		if(bit.band(libTConstants.Unit.TARGET, value)==libTConstants.Unit.TARGET)then s = s .. "Target," end
		if(bit.band(libTConstants.Unit.FOCUS, value)==libTConstants.Unit.FOCUS)then  s = s .. "Focus," end
		if(bit.band(libTConstants.Unit.FOCUSTARGET, value)==libTConstants.Unit.FOCUSTARGET)then  s = s .. "Focus's Target," end
		if(bit.band(libTConstants.Unit.TARGETSTARGET, value)==libTConstants.Unit.TARGETSTARGET)then  s = s .. "Targets Target," end
		return s
	end,
	toShortString = function(value)
		local s = ""
		if(bit.band(libTConstants.Unit.PLAYER, value)==libTConstants.Unit.PLAYER)then s = s .. "P -" else s = s .. "   " end
		if(bit.band(libTConstants.Unit.TARGET, value)==libTConstants.Unit.TARGET)then s = s .. "T -" else s = s .. "   " end
		if(bit.band(libTConstants.Unit.FOCUS, value)==libTConstants.Unit.FOCUS)then  s = s .. "F -" else s = s .. "   " end
		if(bit.band(libTConstants.Unit.FOCUSTARGET, value)==libTConstants.Unit.FOCUSTARGET)then  s = s .. "FT-" else s = s .. "   " end
		if(bit.band(libTConstants.Unit.TARGETSTARGET, value)==libTConstants.Unit.TARGETSTARGET)then  s = s .. "TT-" else s = s .. "   " end
		return s
	end
}

libTConstants.UnitSpecifiersStrings = {
	[1] = "player",
	[2] = "player.target",
	[4] = "focus",
	[8] = "focus.target",
	[16] = "player.target.target",
}

libTConstants.RelationMap = {
	["hostile"] = 1,
	["friendly"] = 2
}

--TriggerType
libTConstants.CatalogItemType = {
	BUFF = 1,
	ABILITY = 2,
	CASTBAR = 4,
	RESOURCE = 8,
	ALL = 999999,
	toString = function (value)
		local map = {"Buff","Ability","Resource","Cast"}
		return map[value]
	end
}

libTConstants.Roles = {
	DPS = 1,
	TANK = 2,
	HEALER = 4,
	SUPPORT = 8,
	toString = function(value)
		local s = ""
		if(bit.band(libTConstants.Roles.DPS, value)==libTConstants.Roles.DPS)then s = s .. "DPS," end
		if(bit.band(libTConstants.Roles.TANK, value)==libTConstants.Roles.TANK)then s = s .. "Tank," end
		if(bit.band(libTConstants.Roles.HEALER, value)==libTConstants.Roles.HEALER)then s = s .. "Healer," end
		if(bit.band(libTConstants.Roles.SUPPORT, value)==libTConstants.Roles.SUPPORT)then s = s .. "Supprt," end
		return s
	end,
	toShortString = function(value)
		local s = ""
		if(bit.band(libTConstants.Roles.DPS, value)==libTConstants.Roles.DPS)then s = s .. "D" else s = s .. " " end
		if(bit.band(libTConstants.Roles.TANK, value)==libTConstants.Roles.TANK)then s = s .. "T" else s = s .. " " end
		if(bit.band(libTConstants.Roles.HEALER,value)==libTConstants.Roles.HEALER)then s = s .. "H" else s = s .. " " end
		if(bit.band(libTConstants.Roles.SUPPORT, value)==libTConstants.Roles.SUPPORT)then s = s .. "S" else s = s .. " " end
		return s
	end
}

libTConstants.Relation = {
		HOSTILE = 1,
		FRIENDLY = 2,
		toString = function (value)
			local map = {"Hostile","Friendly"}
			return map[value]
		end
		}

libTConstants.BuffState = {
	ACTIVE = 1,
	MISSING = 2,
		toString = function (value)
			local map = {"Active","Missing"}
			return map[value]
		end
}

libTConstants.AbilityState = {
	READY = 1,
	COOLDOWN = 2,
		toString = function (value)
			local map = {"Ready","Cooldown"}
			return map[value]
		end
}