libTUtility = ...

local random = math.random
function libTUtility.uuid()
  local template ='xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'
  return string.gsub(template, '[xy]', function (c)
      local v = (c == 'x') and random(0, 0xf) or random(8, 0xb)
      return string.format('%x', v)
  end)
end

-- Taken directly from Karuul's alerts - No shame all credit to the Karuul's team
local b = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

-- encoding
function libTUtility.EncodeBase64(data)
	return ((data:gsub('.', function(x) 
		local r,b='',x:byte()
		for i = 8, 1 ,-1 do
			r = r .. (b % 2 ^ i - b % 2 ^ (i - 1)> 0 and '1' or '0') end
		return r;
	end)..'0000'):gsub('%d%d%d?%d?%d?%d?', function(x)
		if (#x < 6) then return '' end
		local c=0
		for i=1,6 do c=c+(x:sub(i,i)=='1' and 2^(6-i) or 0) end
		return b:sub(c+1,c+1)
	end))
end

-- decoding
function libTUtility.DecodeBase64(data)
	data = string.gsub(data, '[^'..b..'=]', '')
	return (data:gsub('.', function(x)
		if (x == '=') then return '' end
		local r,f='',(b:find(x)-1)
		for i=6,1,-1 do r=r..(f%2^i-f%2^(i-1)>0 and '1' or '0') end
		return r;
	end):gsub('%d%d%d?%d?%d?%d?%d?%d?', function(x)
		if (#x ~= 8) then return '' end
		local c=0
		for i=1,8 do c=c+(x:sub(i,i)=='1' and 2^(8-i) or 0) end
		return string.char(c)
	end))
end

function libTUtility.Trim(s)
    if(s == nil)then return nil end
    local from = s:match"^%s*()" 
    return from > #s and "" or s:match(".*%S", from)
end

function libTUtility.Checksum(data)
	local checksum = Utility.Storage.Checksum(data)
	local shortCheck = string.sub(checksum, -6)
	
	local bytes = {}
	for hexPair in shortCheck:gmatch("(%x%x)") do
    	table.insert(bytes, string.char(tonumber(hexPair, 16)))
	end
	
	return libTUtility.EncodeBase64(table.concat(bytes))
end

function libTUtility.explode(div,str)
    if (div=='') then return false end
    local pos,arr = 0,{}
    for st,sp in function() return string.find(str,div,pos,true) end do
        table.insert(arr,string.sub(str,pos,st-1))
        pos = sp + 1
    end
    table.insert(arr,string.sub(str,pos))
    return arr
end

function libTUtility.TableToString(t)
   local print_r_cache={}
   local retVal = {}
   local function sub_print_r(t,indent)
       if (print_r_cache[tostring(t)]) then
           table.insert(retVal,indent.."*"..tostring(t))
       else
           print_r_cache[tostring(t)]=true
           if (type(t)=="table") then
               for pos,val in pairs(t) do
                   if (type(val)=="table") then
                       table.insert(retVal,indent.."["..pos.."] => "..tostring(t).." {")
                       sub_print_r(val,indent..string.rep(" ",string.len(pos)+8))
                       table.insert(retVal,indent..string.rep(" ",string.len(pos)+6).."}")
                   elseif (type(val)=="string") then
                       table.insert(retVal,indent.."["..pos..'] => "'..val..'"')
                   else
                       table.insert(retVal,indent.."["..pos.."] => "..tostring(val))
                   end
               end
           else
               table.insert(retVal,indent..tostring(t))
           end
       end
   end
   if (type(t)=="table") then
       table.insert(retVal,tostring(t).." {")
       sub_print_r(t,"\t")
       table.insert(retVal,"}")
   else
       sub_print_r(t,"\t")
   end
   return table.concat(retVal,"\n")
end

function libTUtility.StringSplit(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={} ; i=1
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end
        return t
end


function libTUtility.StringSplitToTable(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={} ; i=1 ; tt = {}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end
        i = 1
        while i < #t do
            tt[t[i]] = t[i + 1]
            i = i + 2
        end 
        return tt
end