--
--  Class menuItem_ShowFilter

local addonData, triggers = ...

local menuItem_ShowFilter = {}
menuItem_ShowFilter.__index = menuItem_ShowFilter

function menuItem_ShowFilter.Create()
	local obj = {}
	setmetatable(obj,menuItem_ShowFilter)
	obj:Init()
	return obj
end

function menuItem_ShowFilter:Init()
	self.items = {}
	self.description = "Filter"
	self.parent = nil
	self.selfDrawn = true
end

function menuItem_ShowFilter:CunstructMenuItem(parent, attachTo, width)
	self.parent = parent
	self.width = width
	self.roles = {"Current"}
	local roleList = Inspect.Role.List()
	for _,v in  pairs(roleList)do
		table.insert(self.roles,v)
	end

	self.frame = UI.CreateFrame("Frame",self.description, parent)
	self.frame.parent = parent
	self.frame:SetWidth(self.width)
	self.frame:SetHeight(120)
	self.frame:SetMouseMasking("limited")
	self.frame:SetLayer(3)
	self.frame:SetPoint("TOPLEFT", attachTo, "BOTTOMLEFT")

	self.frame.text = UI.CreateFrame("Text", self.description .. "_HeaderText", self.frame)
	self.frame.text:SetPoint("TOPCENTER", self.frame, "TOPCENTER")
	self.frame.text:SetText("Filter")
	self.frame.text:SetFontColor(1,1,0)
	self.frame.text:SetFontSize(15)

	self.frame.rolesListScrollView = UI.CreateFrame("SimpleScrollView", self.description .. "_RoleList",self.frame)
	self.frame.rolesListScrollView:SetPoint("BOTTOMLEFT", self.frame, "BOTTOMLEFT",0,0)
	self.frame.rolesListScrollView:SetWidth(self.width)
	self.frame.rolesListScrollView:SetHeight(100)
	self.frame.rolesListScrollView:SetShowScrollbar(true)

	self.frame.roleList = UI.CreateFrame("SimpleList", self.description .. "_AbilityList_SimpleList", self.frame.rolesListScrollView)
	self.frame.roleList:SetFontSize(14)
	self.frame.rolesListScrollView:SetContent(self.frame.roleList)
	self.frame.rolesListScrollView:SetVisible(true)
	self.frame.roleList:SetItems(self.roles)

	self.frame.roleList:SetSelectedIndex(1, true)
	triggers.Notifications:SpecDisplayFilter(self)

	Command.Event.Attach(Event.TEMPORARY.Role,menuItem_ShowFilter.RoleChange,"menuItem_ShowFilter.RoleChange")
	return self.frame
end

function menuItem_ShowFilter:Spec()
	local i = self.frame.roleList:GetSelectedItem()
	if(i == "Current")then
		return nil
	end
	return i
end


function menuItem_ShowFilter.RoleChange()
	local self = triggers.menuItem_ShowFilter
	self.frame.roleList:SetSelectedIndex(1, true)
end

triggers.menuItem_ShowFilter = menuItem_ShowFilter.Create()

