--
-- Class ColorPicker
--
--   Manages a list of ColorPicker

local addonData, triggers = ...

local ColorPicker = {}
ColorPicker.__index = ColorPicker

function ColorPicker.Create(notification)
	local obj = {}
	setmetatable(obj,ColorPicker)
	obj:Init()
	obj.notification = notification
	return obj
end

function ColorPicker:Init()
	self.size = { width = 370, height = 80 }
	self.description = "ColorPicker"
end

function ColorPicker.ColorChosen(r, g, b)
	self = triggers.ColorPicker
	self.frame:SetVisible(false)
	r=math.floor(r*1000) / 1000
	g=math.floor(g*1000) / 1000
	b=math.floor(b*1000) / 1000	
	self.handler(r, g, b)
end

function ColorPicker.UISetup(handle,parent)
	self = triggers.ColorPicker
	self.parent = parent
	self.frame = UI.CreateFrame("Frame",self.description, self.parent)
	self.frame:SetWidth(self.size.width)
	self.frame:SetHeight(self.size.height)
	self.frame:SetLayer(201)
	Library.LibSimpleWidgets.SetBorder("rounded", self.frame, 1,1,1,1)
	self.frame:SetBackgroundColor(0.05,0.05,0.05,.95)
	self.frame.config = self
	self.frame:SetPoint("CENTER",UIParent, "CENTER")
	self.myCurrentPoint = "CENTER"
	self.frame:SetVisible(false)
	Library.ColorChooser.CreateWidget(self.frame, ColorPicker.ColorChosen, 10, false)
end

function ColorPicker.Display(handler,myPoint,frame,referencePoint,x,y)
	self = triggers.ColorPicker
	self.frame:ClearPoint(self.myCurrentPoint)
	self.myCurrentPoint = myPoint
	self.handler = handler
	self.frame:SetPoint(myPoint,frame,referencePoint,x,y)
	self.frame:SetVisible(true)
end

triggers.ColorPicker = ColorPicker.Create()

Command.Event.Attach(Triggers.Event.ContextCreated , ColorPicker.UISetup, "ColorPicker.UISetup")
